Package groovy.transform

# Enum DefaultsMode

java.lang.Object
java.lang.Enum<DefaultsMode>
groovy.transform.DefaultsMode

All Implemented Interfaces:
  `Serializable`, `Comparable<DefaultsMode>`, `java.lang.constant.Constable`

public enum DefaultsMode extends Enum<DefaultsMode>
Intended mode to use when generating constructors to emulate default parameter values when using the `TupleConstructor` annotation.

Since:
  4.0.0
See Also:
  - `TupleConstructor`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `AUTO`
  Produce multiple constructors as required to handle any mandatory and optional arguments.
  `OFF`
  Produce a single constructor corresponding to the complete list of properties/fields of the class being compiled.
  `ON`
  Produce multiple constructors as required from all parameters through to the no-arg constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultsMode`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static DefaultsMode[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### OFF

    public static final DefaultsMode OFF
    Produce a single constructor corresponding to the complete list of properties/fields of the class being compiled.

  - ### AUTO

    public static final DefaultsMode AUTO
    Produce multiple constructors as required to handle any mandatory and optional arguments. An argument is optional if the respective property/field has an explicit initial value. A property/field without an initial value is deemed mandatory.

  - ### ON

    public static final DefaultsMode ON
    Produce multiple constructors as required from all parameters through to the no-arg constructor. Defaults will be set according to any explicit initial values or the default value otherwise.

- ## Method Details

  - ### values

    public static DefaultsMode[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static DefaultsMode valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null